<template>
<div class="row">
    <div class="col-lg-12">
        <div class="wrapper wrapper-content animated fadeInUp">
            <div class="ibox">
                <div class="ibox-content" v-bind:class="{ 'sk-loading':loading }">
                    <div class="sk-spinner sk-spinner-wave">
                        <div class="sk-rect1"></div>
                        <div class="sk-rect2"></div>
                        <div class="sk-rect3"></div>
                        <div class="sk-rect4"></div>
                        <div class="sk-rect5"></div>
                    </div>
                    <div class="row">
                        <div class="col-lg-12">
                            <div class="m-b-md">
                                <div>
                                    <a v-if="!loading" @click="get_details()" class="btn btn-default btn-sm pull-right">
                                        Refresh
                                    </a>
                                    <a class="pull-right">&nbsp;</a>
                                    <a v-if="!loading" @click="modal_show()" class="btn btn-primary btn-sm pull-right">
                                        Edit Employee
                                    </a>
                                    <a class="pull-right">&nbsp;</a>
                                    <a v-if="!loading" @click="pan_modal_show()" class="btn btn-primary btn-sm pull-right">
                                        Add New PAN
                                    </a>
                                    <a class="pull-right">&nbsp;</a>
                                    <a v-if="!loading" @click="$router.go(-1)" class="btn btn-default btn-sm pull-right">
                                        <i class="fa fa-chevron-left"></i>
                                    </a>
                                </div>
                                <h2><strong>Employee: </strong> Personal Info</h2>
                            </div>
                            <dl class="dl-horizontal">
                                <dt>Full Name:</dt>
                                <dd><strong class="text-navy">{{ employee.details.full_name }}</strong></dd>
                            </dl>
                        </div>
                    </div>
                    <div class="row" v-if="loading">
                        <div class="col-lg-5">
                            <dl class="dl-horizontal">
                                <dt>Last Name:</dt><dd>{{ employee.details.last_name }}</dd>
                                <dt>First Name:</dt> <dd>{{ employee.details.first_name }}</dd>
                                <dt>Middle Name:</dt> <dd>{{ employee.details.middle_name }}</dd>
                            </dl>
                        </div>
                        <div class="col-lg-7" id="cluster_info">
                            <dl class="dl-horizontal">
                                <dt>Date Hired:</dt><dd>{{ employee.details.display_hired_date }}</dd>
                                <dt>Date Of Birth:</dt> <dd>{{ employee.details.display_birth_date }}</dd>
                                <dt>Civil Status:</dt> <dd>{{ employee.details.civil_status }}</dd>
                            </dl>
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-lg-5">
                            <dl class="dl-horizontal">
                                <dt>Spouse's Name:</dt> <dd>{{ employee.details.spouse_name }}</dd>
                                <dt>Mother's Name:</dt> <dd>{{ employee.details.mother_name }}</dd>
                                <dt>Contact #:</dt> <dd>{{ employee.details.contact_num }}</dd>
                                <dt>No. of Children :</dt> <dd>{{ employee.details.no_of_children }}</dd>
                                <dt>No. of Dependent :</dt> <dd>{{ employee.details.no_of_dependent }}</dd>
                            </dl>
                        </div>
                        <div class="col-lg-7" id="cluster_info">
                            <dl class="dl-horizontal">
                                <dt>SSS #:</dt><dd>{{ employee.details.sss_no }}</dd>
                                <dt>TIN #:</dt> <dd>{{ employee.details.tin_no }}</dd>
                                <dt>Philhealth #:</dt> <dd>{{ employee.details.philhealth_no }}</dd>
                                <dt>HDMF #:</dt> <dd>{{ employee.details.hdmf_no }}</dd>
                                <dt>HDMF EE:</dt> <dd>P {{ employee.details.hdmf_ee }}</dd>
                                <dt>Payroll Account #:</dt> <dd>{{ employee.details.payroll_account }}</dd>
                            </dl>
                            
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-lg-12">
                            <dl class="dl-horizontal">
                                <dt>Address:</dt>
                                <dd>{{ employee.details.address }}</dd>
                            </dl>
                        </div>
                    </div>

                    <div class="row m-t-sm" v-if="true">
                        <div class="col-lg-12">
                            <div class="panel blank-panel">
                                <div class="panel-heading">
                                    <div class="panel-options">
                                        <ul class="nav nav-tabs">
                                            <li class="active"><a href="#tab-1" data-toggle="tab">Personnel Action Notice</a></li>
                                            <li class=""><a href="#tab-2" data-toggle="tab" v-if="false">Deductions</a></li>
                                        </ul>
                                    </div>
                                </div>

                                <div class="panel-body">

                                    <div class="tab-content">
                                        <div class="tab-pane active" id="tab-1">
                                            <pan v-bind:pans="employee.pans" 
                                                v-bind:employee="employee.details"
                                                v-bind:latestPan="employee.details.latest_pan"
                                                v-on:edit="pan_modal_show" 
                                                v-on:saveStatus="pan_save_status">
                                            </pan>
                                        </div>
                                        <div class="tab-pane" id="tab-2">
                                            <div class="feed-activity-list" v-if="false">
                                                <div class="feed-element">
                                                    <a href="#" class="pull-left">
                                                        <img alt="image" class="img-circle" src="img/a2.jpg">
                                                    </a>
                                                    <div class="media-body ">
                                                        <small class="pull-right">2h ago</small>
                                                        <strong>Mark Johnson</strong> posted message on <strong>Monica Smith</strong> site. <br>
                                                        <small class="text-muted">Today 2:10 pm - 12.06.2014</small>
                                                        <div class="well">
                                                            Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry's standard dummy text ever since the 1500s.
                                                            Over the years, sometimes by accident, sometimes on purpose (injected humour and the like).
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    
                                    </div>

                                </div>

                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <employee-modal  v-on:save="employee_update" v-bind:modal="modal"></employee-modal>
    <pan-modal  v-on:save="pan_save" v-bind:modal="pan_modal"></pan-modal>
</div>
</template>

<script>
import axios from 'axios'
import Modal from './Modal.vue'
import PAN from './PAN/PAN.vue'
import PANModal from './PAN/Modal.vue'
import Spinner from '../../other/Spinner.vue'
import appService from '../../../app.service.js'
import { mapGetters } from 'vuex'

export default {
    computed: {
      ...mapGetters('optionListModule', [
          'brands',
        ])
    },
    data() {
        return {
            employee: {
                details: {},
                pans: {}
            },
            modal: {
                pause_save: false,
                errors: '',
                data: {}
            },
            loading: true,
            pause_reset: false,

            pan_modal: {
                pause_save: false,
                errors: '',
                data: {}
            },
        }
    },
    components: {
        'employee-modal': Modal,
        'pan': PAN,
        'pan-modal': PANModal,
        'spinner': Spinner
    },
    methods: {
        get_details () {
            this.loading = true
            let id = this.$route.params.id
            if( !id ) {
                this.$router.push({ name: 'employee' })
            }else{
                axios.get(`employee/${id}`).then(response => {
                    this.employee = response.data.employee
                    this.loading = false  
                })
            }
        },
        modal_show() {
            this.modal.errors = ''
             this.modal.data = this.employee.details
            $('#employee_modal').modal('show');
        },
        employee_update( data ){
            this.modal.pause_save = true
            this.loading = true
            axios.put(`/employee/${this.employee.details.id}`,  data ).then(response => {
                if(response.data.errors) {
                    this.modal.errors = response.data.errors
                }else{
                    $('#employee_modal').modal('hide')
                    toastr.success( response.data.message, 'Updated!' )
                    this.get_details()
                }
                this.loading = false 
                this.modal.pause_save = false 
            })
        },
        employee_delete(){
            this.loading = true
            appService.crud.delete( `/employee/${this.employee.details.id}` ).then(response => {
                if(response.errors) {
                    toastr.error( response.message, 'Error!' )
                }else{
                    toastr.error( response.message, 'Deleted!' )
                    this.get_details()
                }
            }) 
            this.loading = false 
        },

        // Pan
        pan_modal_show( data = '') {
            this.pan_modal.errors = ''
            this.pan_modal.pause_save = false

            if(!data) {
                this.pan_modal.data = {
                    nature: '',
                    department: '',
                    pay_class: '',
                    superior: '',
                    basic_salary: 0,
                    other_allow: 0,
                    rice_allow: 0,
                    laundry_allow: 0,
                    clothing_allow: 0,
                    medical_allow: 0,
                    ob_allow: 0,
                    ecola: 0,
                }
            }else{
                this.pan_modal.data = data
            }
            
            $('#pan_modal').modal('show');
        },
        pan_save( data ) {
            if(!data.id) {
                this.pan_store(data)
            }else{
                this.pan_update(data)
            }
        },
        pan_store(data) {
           this.pan_modal.pause_save = true
            appService.crud.store( `employee/${this.employee.details.id}/pan`, data ).then(response => {
                if(response.errors) {
                    this.pan_modal.errors = response.errors
                }else if(response.error){
                    $('#pan_modal').modal('hide')
                    toastr.error( response.message, 'Error!' )
                }else{
                    $('#pan_modal').modal('hide')
                    toastr.success( response.message, 'Saved!' )
                }
                this.get_details()
                this.pan_modal.pause_save = false
            })
        },
        pan_update(data) {
            this.pan_modal.pause_save = true
            axios.put(`/employee/${this.employee.details.id}/pan/${data.id}`,  data ).then(response => {
                if(response.data.errors) {
                    this.pan_modal.errors = response.data.errors
                }else if(response.data.error){
                    $('#pan_modal').modal('hide')
                    toastr.error( response.message, 'Error!' )
                }else{
                    $('#pan_modal').modal('hide')
                    toastr.success( response.data.message, 'Updated!' )
                }
                this.get_details()
                this.pan_modal.pause_save = false 
            })
        },
        pan_save_status(id) {
            axios.put(`/employee/${this.employee.details.id}/pan/${id}/save`).then(response => {
                this.get_details()
                if(response.data.errors) {
                    this.pan_modal.errors = response.data.errors
                }else if(response.error){
                    toastr.error( response.data.message, 'Error!' )
                }else{
                    toastr.success( response.data.message, 'Status updated!' )
                }
            })
        }   
    },
    created() {
        this.get_details()
    }
}
</script>

